# Changelog

This document outlines major changes between releases.

## [Unreleased]

### Added
- Stop pool dial on SIGINT (#76)

### Changed
- Configuration parameters (#66, #71)

### Updating from v0.5.0

Now all pool config parameters moved to `pool` section. So you need to change:

* `peers` -> `pool.peers` (`REST_GW_PEERS` -> `REST_GW_POOL_PEERS`)
* `node-dial-timeout` -> `pool.node-dial-timeout` (`REST_GW_NODE_DIAL_TIMEOUT` -> `REST_GW_POOL_NODE_DIAL_TIMEOUT`)
* `healthcheck-timeout` -> `pool.healthcheck-timeout` (`REST_GW_HEALTHCHECK_TIMEOUT` -> `REST_GW_POOL_HEALTHCHECK_TIMEOUT`)
* `rebalance-timer` -> `pool.rebalance-timer` (`REST_GW_REBALANCE_TIMER` -> `REST_GW_POOL_REBALANCE_TIMER`)
* `pool-error-threshold` -> `pool.error-threshold` 

Besides all other parameters that doesn't belong any section, now in `server` section:
* `listen-address` -> `server.listen-address`

The same should be done for the following parameters as well:
```
scheme, cleanup-timeout, graceful-timeout, max-header-size, listen-limit, keep-alive, read-timeout, write-timeout, 
tls-listen-address, tls-certificate, tls-key, tls-ca, tls-listen-limit, tls-keep-alive, tls-read-timeout, tls-write-timeout
```

Environment variables should be changed appropriately.

## Older versions

This project is a fork of [NeoFS REST Gateway](https://github.com/nspcc-dev/neofs-rest-gw) from version v0.5.0.
To see CHANGELOG for older versions, refer to https://github.com/nspcc-dev/neofs-rest-gw/blob/master/CHANGELOG.md.

[Unreleased]: https://git.frostfs.info/TrueCloudLab/frostfs-http-gw/compare/3a1a17b8...master
